mklive.sh.in 13 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419
  1. #!/bin/bash
  2. #
  3. # vim: set ts=4 sw=4 et:
  4. #
  5. #-
  6. # Copyright (c) 2009-2013 Juan Romero Pardines.
  7. # All rights reserved.
  8. #
  9. # Redistribution and use in source and binary forms, with or without
  10. # modification, are permitted provided that the following conditions
  11. # are met:
  12. # 1. Redistributions of source code must retain the above copyright
  13. # notice, this list of conditions and the following disclaimer.
  14. # 2. Redistributions in binary form must reproduce the above copyright
  15. # notice, this list of conditions and the following disclaimer in the
  16. # documentation and/or other materials provided with the distribution.
  17. #
  18. # THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
  19. # IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
  20. # OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
  21. # IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
  22. # INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
  23. # NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  24. # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  25. # THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  26. # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  27. # THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  28. #-
  29. set -E
  30. trap "echo; error_out $LINENO $?" INT TERM HUP ERR
  31. readonly PROGNAME=$(basename $0)
  32. info_msg() {
  33. printf "\033[1m$@\n\033[m"
  34. }
  35. error_out() {
  36. info_msg "There was an error in line $1 ... cleaning up $BUILDDIR, exiting."
  37. [ -d "$BUILDDIR" ] && rm -rf "$BUILDDIR"
  38. exit 1
  39. }
  40. write_etc_motd() {
  41. cat >> "$ROOTFS/etc/motd" <<_EOF
  42. ###############################################################################
  43. Autogenerated by void-mklive "@@MKLIVE_VERSION@@"
  44. ###############################################################################
  45. Welcome to the Void Linux Live system, you have been autologged in.
  46. This user has full sudo(8) permissions without any password, be careful
  47. executing commands through sudo(8).
  48. To start the installation please type:
  49. $ sudo void-installer
  50. and follow the on-screen instructions. Thanks for using Void Linux.
  51. http://www.voidlinux.eu
  52. ###############################################################################
  53. _EOF
  54. }
  55. write_conf_file() {
  56. cat > "$1" <<_EOF
  57. # *-*- sh -*-*
  58. # Default configuration file for vmklive-@VERSION@.
  59. #
  60. # List of packages to be installed into the live image.
  61. # NOTE: base-system and dialog packages are always added by default.
  62. #
  63. #PACKAGE_LIST=""
  64. # Default Void Linux splash image for grub/syslinux.
  65. SPLASH_IMAGE=/usr/share/void-artwork/splash.png
  66. # Default keymap to use.
  67. KEYMAP=us
  68. # Default locale to use.
  69. LOCALE=en_US.UTF-8
  70. # Path to XBPS utilities.
  71. #XBPS_INSTALL_CMD=xbps-install
  72. #XBPS_QUERY_CMD=xbps-query
  73. #XBPS_RECONFIGURE_CMD=xbps-reconfigure
  74. #XBPS_REMOVE_CMD=xbps-remove
  75. #XBPS_RINDEX_CMD=xbps-rindex
  76. #XBPS_UHELPER_CMD=xbps-uhelper
  77. # XBPS cache directory to install packages from.
  78. #REPOSITORY_CACHE=/blah/foo
  79. _EOF
  80. chmod 644 "$1"
  81. }
  82. usage() {
  83. cat <<_EOF
  84. Usage: $(basename $0) [options]
  85. Options:
  86. -C file Path to configuration file (defaults to ~/.mklive.conf)
  87. -c (gzip|bzip2|xz) Compression type for the initramfs/squashfs image.
  88. -r rootdir Use this directory to generate the image (if unset, defaults to cwd).
  89. -o outfile Output file name for the ISO image.
  90. -s splash Splash image file for isolinux.
  91. -V Show version.
  92. _EOF
  93. exit 1
  94. }
  95. install_packages() {
  96. for f in ${PACKAGE_LIST}; do
  97. info_msg " $f"
  98. done
  99. # Check that all pkgs are reachable.
  100. ${XBPS_INSTALL_CMD} ${XBPS_ARGS} -n ${PACKAGE_LIST} >>$LOGFILE 2>&1
  101. if [ $? -ne 0 ]; then
  102. info_msg "Missing required binary packages, exiting..."
  103. error_out
  104. fi
  105. ${XBPS_INSTALL_CMD} ${XBPS_ARGS} ${PACKAGE_LIST} >>$LOGFILE 2>&1
  106. ${XBPS_INSTALL_CMD} ${XBPS_ARGS} -u >>$LOGFILE 2>&1
  107. ${XBPS_REMOVE_CMD} ${XBPS_ARGS} -o >>$LOGFILE 2>&1
  108. ${XBPS_QUERY_CMD} -r "$ROOTFS" -l | sort > "${OUTPUT_FILE%.iso}"-package-list.txt
  109. # Enable choosen UTF-8 locale and generate it into the target rootfs.
  110. sed -e "s/\#\(${LOCALE}.*\)/\1/g" -i $ROOTFS/etc/default/libc-locales
  111. systemd-nspawn -D $ROOTFS xbps-reconfigure -fa >>$LOGFILE 2>&1
  112. # Enable some services if found.
  113. if [ -f $ROOTFS/usr/lib/systemd/system/NetworkManager.service ]; then
  114. systemd-nspawn -D $ROOTFS systemctl enable NetworkManager.service >>$LOGFILE 2>&1
  115. fi
  116. install -Dm755 /usr/sbin/void-installer $ROOTFS/usr/sbin/void-installer
  117. }
  118. generate_initramfs() {
  119. # Install required pkgs in a temporary rootdir to create
  120. # the initramfs and to copy required files.
  121. $XBPS_INSTALL_CMD -r $ROOTFS/kernel_temp -Sy \
  122. base-system void-mklive -c $REPOSITORY_CACHE >>$LOGFILE 2>&1
  123. systemd-nspawn -D $ROOTFS/kernel_temp /usr/bin/dracut --${COMPRESSTYPE} \
  124. --force-add "vmklive" "/boot/initrd.lz" $KERNELVERSION >>$LOGFILE 2>&1
  125. mv $ROOTFS/kernel_temp/boot/initrd.lz $BOOT_DIR
  126. cp $ROOTFS/kernel_temp/boot/vmlinuz-$KERNELVERSION $BOOT_DIR/vmlinuz
  127. rm -rf $ROOTFS/kernel_temp
  128. }
  129. generate_isolinux_boot() {
  130. cp -f $SYSLINUX_DATADIR/isolinux.bin "$ISOLINUX_DIR"
  131. cp -f $SYSLINUX_DATADIR/ldlinux.c32 "$ISOLINUX_DIR"
  132. cp -f $SYSLINUX_DATADIR/libcom32.c32 "$ISOLINUX_DIR"
  133. cp -f $SYSLINUX_DATADIR/vesamenu.c32 "$ISOLINUX_DIR"
  134. cp -f $SYSLINUX_DATADIR/libutil.c32 "$ISOLINUX_DIR"
  135. cp -f $SYSLINUX_DATADIR/chain.c32 "$ISOLINUX_DIR"
  136. cp -f $MKLIVE_DATADIR/isolinux.cfg.in \
  137. "$ISOLINUX_DIR"/isolinux.cfg
  138. if [ -f "$SPLASH_IMAGE" ]; then
  139. cp -f $SPLASH_IMAGE "$ISOLINUX_DIR"
  140. fi
  141. sed -i -e "s|@@SPLASHIMAGE@@|$(basename $SPLASH_IMAGE)|" \
  142. -e "s|@@KERNVER@@|${KERNELVERSION}|" \
  143. -e "s|@@KEYMAP@@|${KEYMAP}|" \
  144. -e "s|@@ARCH@@|$(uname -m)|" \
  145. -e "s|@@LOCALE@@|${LOCALE}|" $ISOLINUX_DIR/isolinux.cfg
  146. }
  147. generate_grub_efi_boot() {
  148. cp -f $MKLIVE_DATADIR/grub.cfg $GRUB_DIR
  149. cp -f $MKLIVE_DATADIR/grub_void.cfg.in $GRUB_DIR/grub_void.cfg
  150. sed -i -e "s|@@SPLASHIMAGE@@|$(basename $SPLASH_IMAGE)|" \
  151. -e "s|@@KERNVER@@|${KERNELVERSION}|" \
  152. -e "s|@@KEYMAP@@|${KEYMAP}|" \
  153. -e "s|@@ARCH@@|$(uname -m)|" \
  154. -e "s|@@LOCALE@@|${LOCALE}|" $GRUB_DIR/grub_void.cfg
  155. mkdir -p $GRUB_DIR/fonts
  156. cp -f $GRUB_DATADIR/unicode.pf2 $GRUB_DIR/fonts
  157. # Create EFI vfat image.
  158. dd if=/dev/zero of=$GRUB_DIR/efiboot.img bs=1024 count=4096 >>$LOGFILE 2>&1
  159. mkfs.vfat -F12 -S 512 -n "grub_uefi" "$GRUB_DIR/efiboot.img" >>$LOGFILE 2>&1
  160. GRUB_EFI_TMPDIR="$(mktemp --tmpdir=$HOME -d)"
  161. LOOP_DEVICE="$(losetup --show --find ${GRUB_DIR}/efiboot.img)"
  162. mount -o rw,flush -t vfat "${LOOP_DEVICE}" "${GRUB_EFI_TMPDIR}" >>$LOGFILE 2>&1
  163. mkdir -p "${GRUB_EFI_TMPDIR}/EFI/boot/"
  164. cd "$BUILDDIR"
  165. grub-mkstandalone --directory="/usr/lib/grub/x86_64-efi" \
  166. --format="x86_64-efi" \
  167. --compression="xz" --output="${GRUB_EFI_TMPDIR}/EFI/boot/bootx64.efi" \
  168. "boot/grub/grub.cfg" >>$LOGFILE 2>&1
  169. umount "$GRUB_EFI_TMPDIR"
  170. losetup --detach "${LOOP_DEVICE}"
  171. rm -rf $GRUB_EFI_TMPDIR
  172. }
  173. generate_squashfs() {
  174. # Find out required size for the rootfs and create an ext3fs image off it.
  175. ROOTFS_SIZE=$(du -sk "$ROOTFS"|awk '{print $1}')
  176. mkdir -p "$BUILDDIR/tmp/LiveOS"
  177. dd if=/dev/zero of="$BUILDDIR/tmp/LiveOS/ext3fs.img" \
  178. bs="$((${ROOTFS_SIZE}+($ROOTFS_SIZE/6)))K" count=1 >>$LOGFILE 2>&1
  179. mkdir -p "$BUILDDIR/tmp-rootfs"
  180. mkfs.ext3 -F -m1 "$BUILDDIR/tmp/LiveOS/ext3fs.img" >>$LOGFILE 2>&1
  181. mount -o loop "$BUILDDIR/tmp/LiveOS/ext3fs.img" "$BUILDDIR/tmp-rootfs"
  182. cd $BUILDDIR
  183. cp -a rootfs/* tmp-rootfs/
  184. umount -f "$BUILDDIR/tmp-rootfs"
  185. mkdir -p "$BUILDDIR/LiveOS"
  186. mksquashfs "$BUILDDIR/tmp" "$BUILDDIR/LiveOS/squashfs.img" \
  187. -comp ${COMPRESSTYPE} >>$LOGFILE 2>&1
  188. chmod 444 "$BUILDDIR/LiveOS/squashfs.img"
  189. # Remove rootfs and temporary dirs, we don't need them anymore.
  190. rm -rf "$ROOTFS" "$BUILDDIR/tmp-rootfs" "$BUILDDIR/tmp"
  191. }
  192. generate_iso_image() {
  193. xorriso -as mkisofs \
  194. -iso-level 3 -rock -joliet \
  195. -max-iso9660-filenames -omit-period \
  196. -omit-version-number -relaxed-filenames -allow-lowercase \
  197. -volid "VOID_LIVE" \
  198. -eltorito-boot boot/isolinux/isolinux.bin \
  199. -eltorito-catalog boot/isolinux/boot.cat \
  200. -no-emul-boot -boot-load-size 4 -boot-info-table \
  201. -eltorito-alt-boot -e boot/grub/efiboot.img -isohybrid-gpt-basdat -no-emul-boot \
  202. -isohybrid-mbr $SYSLINUX_DATADIR/isohdpfx.bin \
  203. -output "$OUTPUT_FILE" "$BUILDDIR" >>$LOGFILE 2>&1
  204. }
  205. #
  206. # main()
  207. #
  208. while getopts "C:c:o:r:s:hV" opt; do
  209. case $opt in
  210. C) CONFIG_FILE="$OPTARG";;
  211. c) COMPRESSTYPE="$OPTARG";;
  212. o) OUTPUT_FILE="$OPTARG";;
  213. r) ROOTDIR="$OPTARG";;
  214. s) SPLASH_IMAGE="$OPTARG";;
  215. h) usage;;
  216. V) echo "$PROGNAME @@MKLIVE_VERSION@@"; exit 0;;
  217. esac
  218. done
  219. shift $(($OPTIND - 1))
  220. # Set defaults
  221. if [ -z "$CONFIG_FILE" ]; then
  222. CONFIG_FILE="$HOME/.mklive.conf"
  223. fi
  224. LOGFILE="$(mktemp -t vmklive-XXXXXXXXXX.log)"
  225. if [ -z "$SYSLINUX_DATADIR" ]; then
  226. SYSLINUX_DATADIR=/usr/share/syslinux
  227. fi
  228. if [ -z "$GRUB_DATADIR" ]; then
  229. GRUB_DATADIR=/usr/share/grub
  230. fi
  231. if [ -z "$MKLIVE_DATADIR" ]; then
  232. MKLIVE_DATADIR=/usr/share/void-mklive
  233. fi
  234. if [ -z "$SPLASH_IMAGE" ]; then
  235. SPLASH_IMAGE=/usr/share/void-artwork/splash.png
  236. fi
  237. if [ -z "$XBPS_INSTALL_CMD" ]; then
  238. XBPS_INSTALL_CMD=xbps-install
  239. fi
  240. if [ -z "$XBPS_REMOVE_CMD" ]; then
  241. XBPS_REMOVE_CMD=xbps-remove
  242. fi
  243. if [ -z "$XBPS_QUERY_CMD" ]; then
  244. XBPS_QUERY_CMD=xbps-query
  245. fi
  246. if [ -z "$XBPS_RINDEX_CMD" ]; then
  247. XBPS_RINDEX_CMD=xbps-rindex
  248. fi
  249. if [ -z "$XBPS_UHELPER_CMD" ]; then
  250. XBPS_UHELPER_CMD=xbps-uhelper
  251. fi
  252. if [ -z "$XBPS_RECONFIGURE_CMD" ]; then
  253. XBPS_RECONFIGURE_CMD=xbps-reconfigure
  254. fi
  255. if [ -z "$COMPRESSTYPE" ]; then
  256. COMPRESSTYPE=xz
  257. fi
  258. if [ -z "$REPOSITORYCACHE" ]; then
  259. REPOSITORY_CACHE="/var/cache/xbps"
  260. fi
  261. # Create or read configuration file.
  262. if [ ! -r $CONFIG_FILE ]; then
  263. info_msg "Creating config file at $CONFIG_FILE."
  264. write_conf_file $CONFIG_FILE
  265. fi
  266. . $CONFIG_FILE
  267. if [ -z "$PACKAGE_LIST" ]; then
  268. PACKAGE_LIST="base-system dialog"
  269. else
  270. PACKAGE_LIST="base-system dialog $PACKAGE_LIST"
  271. fi
  272. if [ ! -f $SYSLINUX_DATADIR/isolinux.bin ]; then
  273. echo "Missing required isolinux files in $SYSLINUX_DATADIR, exiting..."
  274. exit 1
  275. fi
  276. # Check for root permissions.
  277. if [ "$(id -u)" -ne 0 ]; then
  278. echo "Must be run as root, exiting..."
  279. exit 1
  280. fi
  281. ISO_VOLUME="VOID_LIVE"
  282. if [ -n "$ROOTDIR" ]; then
  283. BUILDDIR=$(mktemp --tmpdir="$ROOTDIR" -d)
  284. else
  285. BUILDDIR=$(mktemp --tmpdir="$(pwd -P)" -d)
  286. fi
  287. BUILDDIR=$(readlink -f $BUILDDIR)
  288. ROOTFS="$BUILDDIR/rootfs"
  289. BOOT_DIR="$BUILDDIR/boot"
  290. ISOLINUX_DIR="$BOOT_DIR/isolinux"
  291. GRUB_DIR="$BOOT_DIR/grub"
  292. ISOLINUX_CFG="$ISOLINUX_DIR/isolinux.cfg"
  293. mkdir -p $ISOLINUX_DIR $GRUB_DIR
  294. #
  295. # Check there are repos registered before anything.
  296. #
  297. ${XBPS_QUERY_CMD} -L >/dev/null 2>&1
  298. if [ $? -ne 0 ]; then
  299. echo "No repositories available, exiting..."
  300. error_out
  301. fi
  302. XBPS_ARGS="-r $ROOTFS -y"
  303. XBPS_ARGS="$XBPS_ARGS -c $REPOSITORY_CACHE"
  304. XBPS_VERSION=$($XBPS_QUERY_CMD -V|awk '{print $2}')
  305. case $XBPS_VERSION in
  306. # XBPS >= 0.21
  307. [0-9].[2-9][1-9]*) ;;
  308. *) echo "Your xbps utilities are too old ($XBPS_VERSION), 0.21 is required."; exit 1;;
  309. esac
  310. # Sync index for remote repos first.
  311. $XBPS_INSTALL_CMD -r $ROOTFS -S >/dev/null 2>&1
  312. _linux_series=$($XBPS_QUERY_CMD -r $ROOTFS -Rx linux)
  313. KERNELVERSION=$($XBPS_QUERY_CMD -r $ROOTFS -R --property pkgver ${_linux_series})
  314. KERNELVERSION=$($XBPS_UHELPER_CMD getpkgversion $KERNELVERSION)
  315. if [ -z "$OUTPUT_FILE" ]; then
  316. OUTPUT_FILE="$HOME/void-live-$(uname -m)-${KERNELVERSION}-$(date +%Y%m%d).iso"
  317. fi
  318. info_msg "Redirecting stdout/stderr to $LOGFILE ..."
  319. #
  320. # Install live system and specified packages.
  321. #
  322. info_msg "[1/7] Installing packages into the rootfs..."
  323. install_packages
  324. #
  325. # Prepare /etc/motd.
  326. #
  327. mkdir -p "$ROOTFS"/etc
  328. write_etc_motd
  329. #
  330. # Generate the initramfs.
  331. #
  332. info_msg "[2/7] Generating initramfs image ($COMPRESSTYPE)..."
  333. generate_initramfs
  334. #
  335. # Generate the isolinux boot.
  336. #
  337. info_msg "[3/7] Generating isolinux support for PC-BIOS systems..."
  338. generate_isolinux_boot
  339. #
  340. # Generate the GRUB EFI boot.
  341. #
  342. info_msg "[4/7] Generating GRUB support for EFI systems..."
  343. generate_grub_efi_boot
  344. #
  345. # Generate the squashfs image from rootfs.
  346. #
  347. info_msg "[5/7] Generating squashfs image ($COMPRESSTYPE) from rootfs..."
  348. generate_squashfs
  349. #
  350. # Generate the ISO image.
  351. #
  352. info_msg "[6/7] Generating ISO image..."
  353. generate_iso_image
  354. info_msg "[7/7] Removing build directory..."
  355. rm -rf "$BUILDDIR"
  356. hsize=$(du -sh "$OUTPUT_FILE"|awk '{print $1}')
  357. info_msg "Created $(readlink -f $OUTPUT_FILE) ($hsize) successfully."
  358. exit 0